import pygame

class Camera(pygame.Rect):
    camera_slack_x = 64
    camera_slack_y = 48

    def __init__(self, target_rect, sw, sh):
        super(Camera, self).__init__(target_rect.centerx-(sw/2),
                                     target_rect.centery-(sh/2),
                                     sw, sh)

    def update(self, rect, level):
        if self.centerx - rect.centerx > self.camera_slack_x:
            self.left = rect.centerx + self.camera_slack_x - self.width/2
        elif rect.centerx - self.centerx > self.camera_slack_x:
            self.left = rect.centerx - self.camera_slack_x - self.width/2
        if self.centery - rect.centery > self.camera_slack_y:
            self.top = rect.centery + self.camera_slack_y - self.height/2
        elif rect.centery - self.centery > self.camera_slack_y:
            self.top = rect.centery - self.camera_slack_y - self.height/2
        
        # This keeps the camera within the boundaries of the level
        if self.right > level.right_edge - level.tw:
            self.right = level.right_edge - level.tw
        elif self.left < level.tw:
            self.left = level.tw
        if self.top < level.th:
            self.top = level.th
        elif self.bottom > level.bottom_edge:
            self.bottom = level.bottom_edge
        
        return self