import sys
import pygame 
import scene, data
from util import *

class Game:
    def __init__(self):
        pygame.init()
        self.screen = pygame.display.set_mode((SW*2, SH*2), pygame.HWSURFACE  ) # multiplied by 2 to scaling effect
        self.screen.set_alpha(None)
        self.clock = pygame.time.Clock()
        self.fps = 30
        self.current_level = 'data/maps/final.tmx'
        self.manager = scene.SceneMananger(self.screen, self.current_level)

        self.music = pygame.mixer.Channel(3)
        bg = pygame.mixer.Sound(data.filepath('background.ogg','music'))
        self.music.play(bg, -1)


        # get it from https://pyweek.org/e/toba4/
        self._screen = self.screen
        self.screen = self._screen.convert().subsurface(0,0,SW,SH)

    def event_loop(self):
        for event in pygame.event.get():
            self.keys = pygame.key.get_pressed()
            if event.type == pygame.QUIT:
                sys.exit()



    def main_loop(self):
        while  True:
            self.event_loop()            
            self.manager.scene.handle_events(self.keys)
            self.manager.scene.update(self.keys)
            self.manager.scene.render(self.screen)

            caption = "{} - FPS: {:.2f}".format(CAPTION,self.clock.get_fps())
            pygame.display.set_caption(caption)
            tmp = pygame.transform.scale(self.screen, (SW*2, SH*2))
            self._screen.blit(tmp, (0,0))

            pygame.display.update()
            self.clock.tick(self.fps)